com.holonplatform.core.datastore

## Enum DefaultWriteOption

- java.lang.Object
- - java.lang.Enum<DefaultWriteOption>
  - - com.holonplatform.core.datastore.DefaultWriteOption

- All Implemented Interfaces:
    DatastoreOperations.WriteOption, Serializable, Comparable<DefaultWriteOption>

      public enum DefaultWriteOption
      extends Enum<DefaultWriteOption>
      implements DatastoreOperations.WriteOption

  Default Datastore `DatastoreOperations.WriteOption`s enumeration.
  Since:
    5.0.0

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BRING_BACK_GENERATED_IDS` Bring back any auto-generated id value into the `PropertyBox` which was subject of a data manipulation operation, if a corresponding `Property` (using the property name) is available in the box property set.
    `SAVE_DISABLE_INSERT_FALLBACK` By default, the `DatastoreOperations.save(DataTarget, PropertyBox, WriteOption...)` operation should fallback to an `INSERT` type operation when the value existence cannot be consistently verified in the persistence source (for example, is the persistence source entity supports a primary key and the primary key cannot be obtained or the primary key values to use are not provided) to determine whether an `UPDATE` type operation should by performed.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultWriteOption` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static DefaultWriteOption[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### BRING_BACK_GENERATED_IDS

          public static final DefaultWriteOption BRING_BACK_GENERATED_IDS

      Bring back any auto-generated id value into the `PropertyBox` which was subject of a data manipulation operation, if a corresponding `Property` (using the property name) is available in the box property set.

    - #### SAVE_DISABLE_INSERT_FALLBACK

          public static final DefaultWriteOption SAVE_DISABLE_INSERT_FALLBACK

      By default, the `DatastoreOperations.save(DataTarget, PropertyBox, WriteOption...)` operation should fallback to an `INSERT` type operation when the value existence cannot be consistently verified in the persistence source (for example, is the persistence source entity supports a primary key and the primary key cannot be obtained or the primary key values to use are not provided) to determine whether an `UPDATE` type operation should by performed. This write option disables the default behaviour, forcing to throw an error in such kind of situations.

  - ### Method Detail

    - #### values

          public static DefaultWriteOption[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (DefaultWriteOption c : DefaultWriteOption.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DefaultWriteOption valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2019 The Holon Platform. All rights reserved.